package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.event.*;
import java.awt.geom.Point2D;
import javax.swing.JPanel;
public class MouseKey extends JPanel implements MouseListener 
{

    /* Je me suis aid du tuto d'Oracle : http://docs.oracle.com/javase/tutorial/uiswing/events/mouselistener.html 
    et
    http://www.developpez.net/forums/d1196991/java/interfaces-graphiques-java/event-mouse-recuperer-position-souris/
    */
    
    private static boolean keyPressed, inFrame;
    
    public MouseKey()
    {
        keyPressed = false;
        inFrame = true;
    }

    /** Si une touche est enfonce sur la soruis */
    public void mousePressed(MouseEvent e) {
        /* on ne s'interesse qu'au clic droit */
        if(e.getButton() == MouseEvent.BUTTON1)
            keyPressed = true;
    }
    
    /** Si il y a un changement d'tat sur un bouton de la souris */
    public void mouseClicked(MouseEvent e) {
        // ne nous interesse pas
    }

    /** Si on relache un bouton */
    public void mouseReleased(MouseEvent e) {
        // on relache le vouton gauche de la souris
        if(e.getButton() == MouseEvent.BUTTON1)
            keyPressed = false;
    }
    
    /** Si on mets la souris dans la fentre */
    public void mouseEntered(MouseEvent e) {
        inFrame = true;
    }
    
    /** Si on sort la souris de la fentre */
    public void mouseExited(MouseEvent e) {
        inFrame = false;
        keyPressed = false;
    }
    
    /**
    * @return si un bouton est press.
    */
    public static boolean isKeyPressed()
    {
        return keyPressed;
    }
    
    /**
    * @return si le pointeur de la souris est dans la fentre
    */
    public static boolean isInFrame()
    {
        return inFrame;
    }


}