package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.event.*;
import java.awt.geom.Point2D;
import javax.swing.JPanel;
public class MouseMotion extends JPanel implements MouseMotionListener
{
    /* 
        aide : http://docs.oracle.com/javase/tutorial/uiswing/events/mousemotionlistener.html
    */
    private static Point2D.Double pointer;
    
    public MouseMotion()
    {
        pointer = new Point2D.Double();
    }
    
    /**    
    * la souris est dplac 
    * On change la position du pointeur
    */
    public void mouseMoved(MouseEvent e) 
    {
        pointer = new Point2D.Double(e.getX(), e.getY());
    }
    
    /**    
    * La souris est dplac (avec une touche enfonc). 
    * On change la position du pointeur
    */
    public void mouseDragged(MouseEvent e) 
    {
       pointer = new Point2D.Double(e.getX(), e.getY());
    }
    
    /**
    * @return La position de la souris dans la fentre proportionnellement  la taille de base (900*720).
    */
    public static Point2D.Double getMousePointer()
    {            
        // Comme la fentre peut-tre redimentionne on converti la position donn par la mousemotion avec un ratio de la fentre pour retomber sur les coordonnes valable dans le jeu
        if (MouseKey.isInFrame())
        {
            // calcule de la bordure gauche et suprieur de la fentre
            // on suppose que la bordure infrieur = bordure de gauche
            double borderX = Display.getBorderSize().getX() /2D;
            double borderY = Display.getBorderSize().getY() - borderX;
            return new Point2D.Double((pointer.getX() - borderX) * Config.getMousseRate().getX(), ( pointer.getY() - borderY) * Config.getMousseRate().getY());
        }
        else 
            return null;
    }
}