package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.geom.Point2D;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.geom.AffineTransform;
import java.awt.Image;
import java.awt.Graphics2D;
public class BackGround implements IDrawable
{
    private Point2D.Double pPos; 
    private final int WIDTH = 900, HEIGTH = 720;
    public BackGround()
    {
        pPos = new Point2D.Double(0,0);
    }
    
    /**
    * Mets  jours la position du fond en fonction d'un vecteur externe
    * @param vector le vecteur ncessaire  la translation.
    */
    public void translate(Point2D.Double vector)
    {
        pPos = Geom.frameModulo((Geom.add(Geom.inverseVector(vector), pPos)), Config.getFrameX(), Config.getFrameY()) ;
    }
    
    /**
    * Paint le fond
    */
    public void draw(Graphics g)
    {
        //affiche l'image avec les coordonne "normale"
        Graphics2D g2d = (Graphics2D) g;
        AffineTransform at = new AffineTransform();
        at.translate(pPos.getX() * Config.getFrameRate(), pPos.getY() * Config.getFrameRate());
        at.scale(Config.getFrameRate(), Config.getFrameRate());
        g2d.drawImage(Engine.images.backGround, at, null);        
        
        // on dcale l'image vers la gauche
        at = new AffineTransform();
        at.translate((pPos.getX() - Config.getFrameX()) * Config.getFrameRate(), pPos.getY() * Config.getFrameRate());
        at.scale(Config.getFrameRate(), Config.getFrameRate());
        g2d.drawImage(Engine.images.backGround, at, null);
        
        // on dcale l'image vers le haut  gauche
        at = new AffineTransform();
        at.translate((pPos.getX() - Config.getFrameX()) * Config.getFrameRate(), (pPos.getY() - Config.getFrameY()) * Config.getFrameRate());
        at.scale(Config.getFrameRate(), Config.getFrameRate());
        g2d.drawImage(Engine.images.backGround, at, null); 
        
        // on dcale l'image vers le haut
        at = new AffineTransform();
        at.translate(pPos.getX() * Config.getFrameRate(), (pPos.getY() - Config.getFrameY()) * Config.getFrameRate());
        at.scale(Config.getFrameRate(), Config.getFrameRate());
        g2d.drawImage(Engine.images.backGround, at, null);
    }
    
}