package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
public class Key implements KeyListener
{
    private static boolean keyD, keyQ, keyS, keyEsc, keyZ, keySpace;
    
    public Key()
    {
        keyD = false;
        keyQ = false;
        keyS = false;
        keyEsc = false;
        keyZ = false;
        keySpace = false;
    }
    
    /* Accsseur du keyListerner */

    /**
    *   @return si la touche z a t prss.
    */
    public static boolean isKeyZPressed()
    {   
        return keyZ;
    }
    
    /**
    *   @return si la touche q a t prss.
    */
    public static boolean isKeyQPressed()
    {
        return keyQ;
    }

    /**
    *   @return si la touche d a t prss.
    */
    public static boolean isKeyDPressed()
    {
        return keyD;
    }  
       
    
    /**
    *   @return si la touche s a t prss.
    */
    public static boolean isKeySPressed()
    {
        return keyS;
    }

    /**
    *   @return si la touche ESC a t prss.
    */
    public static boolean isKeyEscPressed()
    {
        return keyEsc;
    }

    /**
    *   @return si la touche espace a t prss.
    */
    public static boolean isKeySpacePressed()
    {
        return keySpace;
    }
    
    /**
    * Modifie les variable si un touches est enfonce.
    * Ou affecte directement le jeu.
    */
    @Override
    public void keyPressed(KeyEvent e)
    {
        char key = e.getKeyChar();
        if (key == 'z' || key == 'Z') { keyZ = true; }
        if ((key == 'b' || key == 'B') && !Main.getGame().isGameOver())
        { 
            // Si un jeu est en cours et qu'on presse B
            // on bloque la tourelle du jeu
            Main.getGame().getShip().changeBlocking();
        }
        if (key == 'q' || key == 'Q') { keyQ = true; }
        if (key == 'd' || key == 'D') { keyD = true; }
        if (key == 'p' || key == 'P') 
        { 
            // mets le jeu en pause
            Main.getGame().changeBreackGame();
        }
        if (key == 's' || key == 'S') { keyS = true; }
        if (e.getKeyCode() == KeyEvent.VK_ESCAPE ) { keyEsc = true; }
        if (key == ' ') { keySpace = true; }
        if (key == 'n' || key == 'N') 
        { 
            // Nouvelle partie au niveau courrent
            Main.setGame(new Engine(Main.getDisplay().getWidth(), Main.getDisplay().getHeight()));
        }

    }

    /**
    *   Rinisialise les touches si elles ne sont plus enfonces.
    */
    @Override
    public void keyReleased(KeyEvent e)
    {
        char key = e.getKeyChar();
        if (key == 'z' || key == 'Z') { keyZ = false; }        
        if (key == 'q' || key == 'Q') { keyQ = false; }
        if (key == 'd' || key == 'D') { keyD = false; }
        if (key == 's' || key == 'S') { keyS = false; }
        if (e.getKeyCode() == KeyEvent.VK_ESCAPE ) { keyEsc = false; }
        if (key == ' ') { keySpace = false; }
    }

    @Override
    public void keyTyped(KeyEvent e)
    {

    }

}